<?php

defined('ABSPATH') or die("No script kiddies please!");



/*-----------------------------------------------------------------------------------*/
/*	Licence management section
/*-----------------------------------------------------------------------------------*/

if ( ! function_exists( 'ag_plugin_licence' ) ) {

	add_action('admin_menu', 'ag_plugin_licence');
	function ag_plugin_licence() {
	  add_menu_page('AG License Activation Menu', 'AG Plugins', 'manage_options', 'AG_licence', 'AG_plugins_page', 'dashicons-admin-network');
		//plugins_url( 'AG-Woo-SagePay-Server/img/weareag.svg' )
	}

}


if ( ! function_exists( 'AG_plugins_page' ) ) {

	function AG_plugins_page() {
	    echo '<div class="wrap">';
	    echo '<h2>We are AG Plugin License Management</h2>';
			echo '<p>Please enter the license key for this product to activate it. You were given a license key when you purchased this item.</p>';

			do_action( 'load_ag_plugins' );

			echo '<p>When moving plugin from one site to another (from development server to live site) you <strong>MUST</strong> deactivate your plugin first on development before you move it over.</p>';
	    echo '</div>';
	}

}

/*-----------------------------------------------------------------------------------*/
/*	End
/*-----------------------------------------------------------------------------------*/


add_action( 'load_ag_plugins', 'epdq_licence_setting' );
function epdq_licence_setting() {

	/*** License activate button was clicked ***/
	if (isset($_REQUEST['PS_ePDQ_key_activate_license'])) {
		$license_key = $_REQUEST['PS_ePDQ_key'];

		// API query parameters
		$api_params = array(
			'slm_action' => 'slm_activate',
			'secret_key' => AGD_KEY,
			'license_key' => $license_key,
			'registered_domain' => $_SERVER['SERVER_NAME'],
			'item_reference' => urlencode(ITEM),
			'product_id' => '1283, 2132, 2133, 2134',
		);

		// Send query to the license manager server
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));

		// License data.
		$license_data = json_decode(wp_remote_retrieve_body($response));

		// TODO - Do something with it.
		//var_dump($license_data);//uncomment it to look at the data

		if($license_data->result == 'success'){//Success was returned for the license activation
				update_option('PS_ePDQ_key', $license_key);
				update_option('PS_ePDQ_key_message', $license_data->message);
				add_option('PS_ePDQ_key_message', $license_data->message);
				$fulldate = $response['headers']['expires'];
				$words = explode(" ", $fulldate);
				$date = join(" ", array_slice($words, 0, 4));
				add_option('PS_ePDQ_key_expires', $date);
				update_option('PS_ePDQ_key_expires', $date);
		} else {
			update_option('PS_ePDQ_key_message', $license_data->message);
		}

	}
	/*** End of license activation ***/

	/*** License activate button was clicked ***/
	if (isset($_REQUEST['PS_ePDQ_key_deactivate_license'])) {
		$license_key = $_REQUEST['PS_ePDQ_key'];

		// API query parameters
		$api_params = array(
			'slm_action' => 'slm_deactivate',
			'secret_key' => AGD_KEY,
			'license_key' => $license_key,
			'registered_domain' => $_SERVER['SERVER_NAME'],
			'item_reference' => urlencode(ITEM),
			'product_id' => '1283, 2132, 2133, 2134',
		);

		// Send query to the license manager server
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));
		if($license_data->result == 'success'){//Success was returned for the license activation
				//Remove the licensse key from the options table. It will need to be activated again.
				update_option('PS_ePDQ_key', '');
				update_option('PS_ePDQ_key_message', $license_data->message);
				echo $response->headers->expires;
		} else {
			update_option('PS_ePDQ_key_message', $license_data->message);
		}

	}

?>
<form action="" method="post" style="padding-top: 20px; padding-bottom: 20px;">
	<table class="form-table">
		<tr><br  />
      <label class="licence_label" for="PS_ePDQ_key"><strong>ePDQ Licence Key</strong></label>
      <th style="width:10px;  padding-bottom: 0;"><input class="regular-text" type="password" id="PS_ePDQ_key" name="PS_ePDQ_key"  value="<?php echo get_option('PS_ePDQ_key'); ?>" ><input type="submit" name="PS_ePDQ_key_activate_license" value="Activate" class="button-primary activate_license" /><input type="submit" name="PS_ePDQ_key_deactivate_license" value="Deactivate" class="button" />
				<?php if (get_option('PS_ePDQ_key_message') == 'License key activated') {
					echo '<p style="color: green"><strong>'. get_option('AGD_SagePay_Key_message'). '</strong></p>';
				} elseif (get_option('PS_ePDQ_key_message') == 'Your License key has expired') {
					echo '<p style="color: red"><strong>'. get_option('PS_ePDQ_key_message'). ' to continue getting support and updates make sure you <a href="">update your licence here</a> now.</strong></p>';
				} else {
					echo '<p style="color: red"><strong>'. get_option('PS_ePDQ_key_message'). '</strong></p>';
				} ?>
  <br  /></tr>
	</table>
	<p style="margin-top: 0; ">Need some help setting up this plugin? <a href="<?php echo site_url(); ?>/wp-admin/index.php?page=welcome-screen-about">Click here</a></p>
</form>
<hr />

<?php

}



class epdq_checkout extends WC_Payment_Gateway {



public function __construct() {
		global $woocommerce;

		$this->id 			= 'epdq_checkout';
		$this->method_title = 'AG EPDQ Checkout';
		$this->icon 		= plugins_url('AG-woocommerce-epdq-payment-gateway/cards.gif');
		$this->has_fields 	= false;

		$license = get_option('PS_ePDQ_key');
		$api_params = array(
			'slm_action' => 'slm_check',
			'secret_key' => AGD_KEY,
			'license_key' => $license,
		);
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));

		// Load the settings.
		//if($license_data->result == 'success'){
			if($this->get_option('refund') == 'yes') {
				$this->init_form_fields_refund();
			} else {
				$this->init_form_fields();
			}
			$this->init_settings();
		//}

		$this->title 		= $this->get_option( 'title' );
		$this->title 		= (isset($this->title) and $this->title !='') ? $this->title : 'EPDQ Checkout';
		if ( $this->status != 'test' ) {
			$this->description 	= $this->get_option( 'description' );
			$this->description .= '<br /><br />' . sprintf( __( '<br /><br /><strong>TEST MODE ACTIVE.</strong><br />In test mode, you can use Visa card number 4444 3333 2222 1111 with any CVC and a valid expiration date or check the documentation <a target="_blank" href="%s">here</a> for more card numbers, steps on setting up and troubleshooting.' ), 'https://www.weareag.co.uk/product/ag-barclays-epdq-payment-gateway-woocommerce/' );
			$this->description  = trim( $this->description );
		} else {
			$this->description 	= $this->get_option( 'description' );
		}
		$this->access_key 	= $this->get_option( 'access_key' );
		$this->api_user 	= $this->get_option( 'api_user' );
		$this->api_password 	= $this->get_option( 'api_password' );

		$this->test_url 	= 'https://mdepayments.epdq.co.uk/ncol/test/orderstandard.asp';
		$this->live_url 	= 'https://payments.epdq.co.uk/ncol/prod/orderstandard.asp';
		$this->status 		= $this->get_option('status');
		$this->error_notice = $this->get_option('error_notice');
		$this->sha_in 		= $this->get_option('sha_in');
		$this->sha_out 		= $this->get_option('sha_out');
		$this->sha_method 	= $this->get_option('sha_method');
		$this->debug	 	= $this->get_option('debug');
		$this->showcase	 	= $this->get_option('showcase');
		$this->logo	 		= $this->get_option('logo');
		$this->prefix	 		= $this->get_option('prefix');
		$this->TITLE = $this->get_option('TITLE');
		$this->sha_method 	= ($this->sha_method !='') ? $this->sha_method : 0;

		// Supports

		//
		// TODO -- Remove 'subscription_date_changes'
		//
		$this->supports = array( 'refunds' );
		//$this->supports = array( 'refunds', 'subscription_date_changes', 'subscriptions'  );


		$this->aavscheck = $this->get_option('aavcheck');
		$this->cvccheck = $this->get_option('cvccheck');



		// Save options
		add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );

		// Payment listener/API hook
		//add_action('woocommerce_receipt_epdq_checkout', array(&$this, 'receipt_page'));
		add_action('woocommerce_thankyou_epdq_checkout', array($this, 'thank_you'));
		//add_action('woocommerce_api_epdq_checkout', array($this, 'check_epdq_response'));

		add_action( 'woocommerce_api_woocommerce_epdq_checkout', array( $this, 'successful_request' ) );
		add_action( 'woocommerce_receipt_epdq_checkout', array( $this, 'receipt_page' ) );
	}

	public function admin_options() {
		global $woocommerce;
		?>

		<h3><?php _e( 'AG EPDQ Checkout Settings', 'woocommerce' );?></h3>
		<p><?php _e('Barclays EPDQ Payment gateway to accept payments directly into your Barclays account. <br /> This gateway will redirect the customers to the secured Barclay payment receiving page and process order there
						and then send them back to the provided links based on the status of their transection.','woocommerce')?></p>

	<?php
			// If the user said yes to showcase
			// Website information
			$websitename = get_option( 'blogname' );
			$websiteurl = get_option ('siteurl');
			$admin_email = get_option( 'admin_email' );
			$showcasedata = array('Website name:', $websitename, 'Website URL: ', $websiteurl, 'Email: ', $admin_email,);
			$showcase = implode("\n", $showcasedata);

			if ($this->showcase == 'yes') {
				// Send the email to support only once the user has ticked that they are happy.
				$to = 'support@weareag.co.uk';
				$subject = 'Epdq plugin showcase';
				$body = $showcase;
				$headers = array('Content-Type: text/html; charset=UTF-8');
				wp_mail( $to, $subject, $body, $headers );
			}
			add_option( 'weareag_prefix', $this->prefix, '', 'yes' );

			// If the user has allowed us to track then collect the follwing so we have better information for debug

			// Theme data
			$theme_data = wp_get_theme();
			$themename = $theme_data->display( 'Name', false, false );
			$themeURL = $theme_data->display( 'ThemeURI', false, false );
			$themeversion = $theme_data->display( 'Version', false, false );

			// Website information
			$websitename = get_option( 'blogname' );
			$websiteurl = get_option ('siteurl');

			// Add all data to array ready for email
			$emaildata = array('Theme name:', $themename, 'Theme URL', $themeURL, 'Theme Version:', $themeversion, 'Website name:', $websitename, 'Website URL: ', $websiteurl);
			//var_dump($emaildata);
			$emailcleandata = implode("\n", $emaildata);

			if ($this->debug == 'yes') {
				// Send the email to support only once the user has ticked that they are happy.
				$to = 'support@weareag.co.uk';
				$subject = 'Epdq debug email';
				$body = $emailcleandata;
				$headers = array('Content-Type: text/html; charset=UTF-8');
				wp_mail( $to, $subject, $body, $headers );
			}

		$license = get_option('PS_ePDQ_key');
		$api_params = array(
			'slm_action' => 'slm_check',
			'secret_key' => AGD_KEY,
			'license_key' => $license,
		);
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));
		echo '<strong>';
		echo $license_data->message;
		echo '</strong>';
		if($license_data->result == 'success'){
			echo '<br />Thank You Purchasing!';
		} else {
			echo '<br />Please activate your licence <a href="'. site_url() .'/wp-admin/admin.php?page=AG_licence">here</a>';
		} ?>
			<table class="form-table">
				<?php $this->generate_settings_html(); ?>
			</table> <!--/.form-table-->

<p>Need some help setting up this plugin? <a href="<?php echo site_url(); ?>/wp-admin/index.php?page=welcome-screen-about">Click here</a></p>



		<?php

	  }

		public function init_form_fields() {
			$this->form_fields = array(
					'enabled' => array(
							'title' => __( 'Enable/Disable', 'woocommerce' ),
							'type' => 'checkbox',
							'label' => __( 'Enable EPDQ Checkout', 'woocommerce' ),
							'default' => 'no'
					),

					'logo' => array(
						'title' => __( 'Logo for payment page', 'woocommerce' ),
						'type' => 'text',
						'label' => __( 'Upload image for payment page', 'woocommerce' ),
						'default' => '',
						'description'=>'Add an image to display on the payment page - paste in the full image url <strong>You must have an SSL for this to work correctly.</strong>',
						'desc_tip'=>false
					),

					'title' => array(
							'title' => __( 'Title', 'woocommerce' ),
							'type' => 'text',
							'description' => __( 'Title of the payment process. This name will be visible throughout the site and the payment page.', 'woocommerce' ),
							'default' => 'EPDQ Checkout',
							'desc_tip'      => true
					),
					'description' => array(
							'title' => __( 'Description', 'woocommerce' ),
							'type' => 'textarea',
							'description' => __( 'Description of the payment process. This description will be visible throuhout the site and the payment page.', 'woocommerce' ),
							'default' => 'Use the payment processor of barclay bank and checkout with your debit/credit card.',
							'desc_tip'      => true
					),
					'access_key' => array(
							'title' => __( 'PSPID', 'woocommerce' ),
							'type' => 'text',
							'description' => __( 'The PSPID for your barclays account. This is the id which you use to login the admin panel of the barclays bank.', 'woocommerce' ),
							'default' => '',
							'desc_tip'      => true
					),
					'status' => array(
							'title' => __( 'Store Status', 'woocommerce' ),
							'type' => 'select',
							'options'=> array('test'=>'Test Environment','live'=>'Live Store'),
							'description' => __( 'The status of your store tells that are you actually ready to run your shop or its still a test environment. If the test is selected then no payments will be processed. For details please refer to the user guide provided by the Barclays EPDQ servise.', 'woocommerce' ),
							'default' => '',
							'css'  => 'height: 35px;',
							'desc_tip'      => true,
					),
					'sha_in' => array(
							'title' => __( 'SHA-IN Passphrase', 'woocommerce' ),
							'type' => 'text',
							'description' => __( 'The SHA-IN signature will encode the parameter passed to the payment processor via the hidden fields to ensure better security.', 'woocommerce' ),
							'default' => '',
							'desc_tip'      => true
					),
					'sha_out' => array(
							'title' => __( 'SHA-OUT Passphrase', 'woocommerce' ),
							'type' => 'text',
							'description' => __( 'The SHA-OUT signature will encode the parameter passed to the redirection url from the payment processor to ensure better security.', 'woocommerce' ),
							'default' => 0,
							'desc_tip'      => true
					),
					'sha_method' => array(
							'title' => __( 'SHA encription method', 'woocommerce' ),
							'type' => 'select',
							'css'  => 'height: 35px;',
							'options'=> array(0=>'SHA-1',1=>'SHA-256',2=>'SHA-512'),
							'description' => __( 'Sha encryption method - this needs to be similar waht you have set in the epdq backoffice.', 'woocommerce' ),
							'default' => '',
							'desc_tip'      => true,
					),
					'debug' => array(
							'title' => __( 'Allow anonymous tracking.', 'woocommerce' ),
							'type' => 'checkbox',
							'label' => __( 'Enable plugin debug,', 'woocommerce' ),
							'default' => '',
							'description'=>'Please allow our plugin to track anonymous data, so that we can strongly improve our plugin and your user experience. This will *not* slow down your website or allow us access to your website. ',
							'desc_tip'=>true
						),
					'refund' => array(
						'title' => __( 'Refunds', 'woocommerce' ),
						'type' => 'checkbox',
						'label' => __( 'Process refunds in order screen', 'woocommerce' ),
						'default' => '',
						'description'=>'Once the save changes button has been clicked two new fields will show which will need to be set to process refunds on the website.',
						'desc_tip'=>true
					),
					'prefix' => array(
						'title' => __( 'Add a prefix to your order numbers', 'woocommerce' ),
						'type' => 'text',
						'label' => __( 'Add a prefix to your order numbers', 'woocommerce' ),
						'default' => '',
						'desc_tip'=>true
					),


			);

		}

	public function init_form_fields_refund() {
		$this->form_fields = array(
				'enabled' => array(
						'title' => __( 'Enable/Disable', 'woocommerce' ),
						'type' => 'checkbox',
						'label' => __( 'Enable EPDQ Checkout', 'woocommerce' ),
						'default' => 'no'
				),

				'logo' => array(
					'title' => __( 'Logo for payment page', 'woocommerce' ),
					'type' => 'text',
					'label' => __( 'Upload image for payment page', 'woocommerce' ),
					'default' => '',
					'description'=>'Add an image to display on the payment page - paste in the full image url <strong>You must have an SSL for this to work correctly.</strong>',
					'desc_tip'=>false
				),

				'title' => array(
						'title' => __( 'Title', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'Title of the payment process. This name will be visible throughout the site and the payment page.', 'woocommerce' ),
						'default' => 'EPDQ Checkout',
						'desc_tip'      => true
				),
				'description' => array(
						'title' => __( 'Description', 'woocommerce' ),
						'type' => 'textarea',
						'description' => __( 'Description of the payment process. This description will be visible throuhout the site and the payment page.', 'woocommerce' ),
						'default' => 'Use the payment processor of barclay bank and checkout with your debit/credit card.',
						'desc_tip'      => true
				),
				'access_key' => array(
						'title' => __( 'PSPID', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'The PSPID for your barclays account. This is the id which you use to login the admin panel of the barclays bank.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true
				),
				'status' => array(
						'title' => __( 'Store Status', 'woocommerce' ),
						'type' => 'select',
						'css'  => 'height: 35px;',
						'options'=> array('test'=>'Test Environment','live'=>'Live Store'),
						'description' => __( 'The status of your store tells that are you actually ready to run your shop or its still a test environment. If the test is selected then no payments will be processed. For details please refer to the user guide provided by the Barclays EPDQ servise.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true,
				),
				'sha_in' => array(
						'title' => __( 'SHA-IN Passphrase', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'The SHA-IN signature will encode the parameter passed to the payment processor via the hidden fields to ensure better security.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true
				),
				'sha_out' => array(
						'title' => __( 'SHA-OUT Passphrase', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'The SHA-OUT signature will encode the parameter passed to the redirection url from the payment processor to ensure better security.', 'woocommerce' ),
						'default' => 0,
						'desc_tip'      => true
				),
				'sha_method' => array(
						'title' => __( 'SHA encription method', 'woocommerce' ),
						'type' => 'select',
						'css'  => 'height: 35px;',
						'options'=> array(0=>'SHA-1',1=>'SHA-256',2=>'SHA-512'),
						'description' => __( 'Sha encryption method - this needs to be similar waht you have set in the epdq backoffice.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true,
				),
				'debug' => array(
						'title' => __( 'Allow anonymous tracking.', 'woocommerce' ),
						'type' => 'checkbox',
						'label' => __( 'Enable plugin debug,', 'woocommerce' ),
						'default' => '',
						'description'=>'Please allow our plugin to track anonymous data, so that we can strongly improve our plugin and your user experience. This will *not* slow down your website or allow us access to your website. ',
						'desc_tip'=>true
					),
				'refund' => array(
					'title' => __( 'Refunds', 'woocommerce' ),
					'type' => 'checkbox',
					'label' => __( 'Process refunds in order screen', 'woocommerce' ),
					'default' => '',
					'description'=>'Once the save changes button has been clicked two new fields will show which will need to be set to process refunds on the website.',
					'desc_tip'=>true
				),
				'api_user' => array(
					'title'		=> __( 'API User ID', 'ag_epdq_checkout' ),
					'type'		=> 'text',
					'desc_tip'	=> __( 'This is to enable you to process refunds via the order screen', 'ag_epdq_checkout' ),
				),
				'api_password' => array(
					'title'		=> __( 'API User Password', 'ag_epdq_checkout' ),
					'type'		=> 'text',
					'desc_tip'	=> __( 'This is to enable you to process refunds via the order screen', 'ag_epdq_checkout' ),
				),
				'prefix' => array(
					'title' => __( 'Add a prefix to your order numbers', 'woocommerce' ),
					'type' => 'text',
					'label' => __( 'Add a prefix to your order numbers', 'woocommerce' ),
					'default' => '',
					'desc_tip'=>true
				),


		);

	}


	/*-----------------------------------------------------------------------------------*/
	/*	Process the payment and return the result
	/*-----------------------------------------------------------------------------------*/
	function process_payment($order_id){

		$order = new WC_Order( $order_id );

		return array(
			'result' 	=> 'success',
			'redirect'	=> $order->get_checkout_payment_url( true )
		);

	}


	/*-----------------------------------------------------------------------------------*/
	/*	receipt_page
	/*-----------------------------------------------------------------------------------*/
	function receipt_page($order_id){
		global $woocommerce;
		$order = new WC_Order( $order_id );

		$this->notify_url = str_replace( 'https:', 'http:', add_query_arg( 'wc-api', 'epdq_checkout', $order->get_checkout_order_received_url() ) );
		$fields = array(
				'PSPID'=>$this->access_key,
				'ORDERID'=>$this->prefix . $order->id,
				'AMOUNT'=>$order->order_total*100,
				'CURRENCY'=>get_woocommerce_currency(),
				'LANGUAGE'=>get_bloginfo('language'),
				'CN'=>$order->billing_first_name . ' ' . $order->billing_last_name,
				'EMAIL'=>$order->billing_email,
				'OWNERZIP'=>$order->billing_postcode,
				'OWNERADDRESS'=>$order->billing_address_1,
				'OWNERADDRESS2'=>$order->billing_address_2,
				'OWNERCTY'=>$woocommerce->countries->countries[$order->billing_country],
				'OWNERTOWN'=>$order->billing_city,
				'OWNERTELNO'=>$order->billing_phone,
				'ACCEPTURL'=>$order->get_checkout_order_received_url(),
				'LOGO'=>$this->logo,
				'TITLE'=> ''
		);


		$shasign ='';
		$shasign_arg = array();
		ksort($fields);
		foreach($fields as $key => $value){
			if($value=='') continue;
			$shasign_arg[] =  $key .'='. $value;
		}

		if( $this->sha_method == 0 )
			$shasign = sha1(implode($this->sha_in, $shasign_arg).$this->sha_in);
		elseif ( $this->sha_method == 1 )
			$shasign = hash('sha256',implode($this->sha_in, $shasign_arg).$this->sha_in);
		elseif ( $this->sha_method == 2 )
			$shasign = hash('sha512',implode($this->sha_in, $shasign_arg).$this->sha_in);
		else{}


		$epdq_args = array();
		foreach($fields as $key => $value){
			if($value=='') continue;
			$epdq_args[] = "<input type='hidden' name='$key' value='$value'/>";
		}

		if( isset($this->status) and ($this->status=='test' or $this->status =='live') ):
			if($this->status=='test')	$url = $this->test_url;
			if($this->status=='live')	$url = $this->live_url;

			echo '<p>'.__('Thank you for your order, please click the button below to pay securely.', 'woocommerce').'</p>';
			echo '<form action="'.$url.'" method="post" id="epdq_payment_form">';
			echo implode('', $epdq_args);
			echo '<input type="hidden" name="SHASIGN" value="'.$shasign.'"/>';
			echo '<input type="submit" class="button alt" id="submit_epdq_payment_form" value="'.__('Pay securely', 'woocommerce').'" />';
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			echo '<a class="button cancel" href="'.$order->get_cancel_order_url().'">'.__('Cancel order &amp; restore cart', 'woocommerce').'</a></form>';
		else:
			echo '<p class="error">'.$this->error_notice.'</p>';
		endif;

		wc_enqueue_js('
			jQuery("body").block({
					message: "'.__('You are now redirecting to Barclays server to make payment securly.', 'ag-epdq').'",
					overlayCSS:
					{
						background: "#fff",
						opacity: 0.6
					},
					css: {
								padding:        20,
								textAlign:      "center",
								color:          "#555",
								border:         "3px solid #aaa",
								backgroundColor:"#fff",
								cursor:         "wait",
								lineHeight:		"32px"
						}
				});
			jQuery("#submit_epdq_payment_form").click();
		');
	}


	function successful_request() {}
	function thank_you() {}


		function process_refund( $order_id, $amount = NULL, $reason = '' ) {

					$order 			   = new WC_Order( $order_id );

					if( is_ssl()) {
						$environment_url = ( "FALSE" == $environment )
											 ? 'https://mdepayments.epdq.co.uk/ncol/prod/maintenancedirect.asp'
											 : 'https://mdepayments.epdq.co.uk/ncol/test/maintenancedirect.asp';
					} else {
						$environment_url = 'https://mdepayments.epdq.co.uk/ncol/test/maintenancedirect.asp';
					}
					$environment_urls = 'https://mdepayments.epdq.co.uk/ncol/test/maintenancedirect.asp';

					$Refundamount = floatval( preg_replace( '#[^\d.]#', '', $amount*100 ) );


					// TODO - fix This


					$data_post;
					$data_post['AMOUNT'] = $amount*100;
					$data_post['OPERATION'] = 'RFD';
					$data_post['PAYID'] = get_post_meta( $order_id, 'PAYID', true );
					$data_post['PSPID'] = $this->access_key;
					$data_post['PSWD'] = $this->api_password;
					$data_post['USERID'] = $this->api_user;

					$post_string = '';

					foreach ($data_post as $key => $value) {
					  $post_string[] = $key. '=' .$value;
					}
					$actual_string = '';
					$actual_string = implode ('&', $post_string);
					$result = wp_remote_post($environment_urls, array(
					  'method' => 'POST',
					  'timeout'     => 6,
					  'redirection' => 5,
					  'body' => $actual_string,
					));
					$lines = preg_split('/\r\n|\r|\n/', $result['body']);
					$response = array();
					foreach ($lines as $line) {
					    $key_value = preg_split('/=/', $line, 2);
					    if (count($key_value) > 1) {
					        $response[trim($key_value[0])] = trim($key_value[1]);
					    }
					}

					$accepted = array(8, 81, 85); // OK

					$status = preg_replace('/[^a-zA-Z0-9\s]/', '', $response['STATUS']);
					$error = preg_replace('/[^a-zA-Z0-9\s]/', '', $response['NCERROR']);

					$string = implode('|',$response);

					if (!is_wp_error($result) && $result['response']['code'] >= 200 && $result['response']['code'] < 300) {

					  if (in_array($status, $accepted)) {
							$order->add_order_note( __('Refund successful', 'ag-sagepay-direct') . '<br />' .
								__('Refund Amount: ', 'ag-sagepay-direct') . $amount . '<br />' .
								__('Refund Reason: ', 'ag-sagepay-direct') . $reason . '<br />' .
								__('ePDQ Status: ', 'ag-sagepay-direct') . get_epdq_status_code($status) . ' '
						);

						return true;


					  } else {
					    $order->add_order_note( __('Refund failed', 'ag-sagepay-direct') . '<br />' . __('ePDQ Status: ', 'ag-sagepay-direct') . get_epdq_status_code($status) . '<br />' );
							$order->add_order_note( __('Refund failed', 'ag-sagepay-direct') . '<br />' . __('ePDQ Error note: ', 'ag-sagepay-direct') . $string . '<br />' );
							$order->add_order_note( __('Debug note:', 'ag-sagepay-direct') . '<br />Refund only possiable once payment has been confirmed in the ePDQ back office.<br />' );

					  }

					}


		}

}


add_filter( 'woocommerce_order_number', 'weareag_order_prefix', 1, 2 );
function weareag_order_prefix( $oldnumber, $order ) {
$prefix = get_option( 'weareag_prefix' );
return $prefix . $order->id; // change weareag to your prefix
}

add_action( 'woocommerce_thankyou_epdq_checkout', 'epdq_transaction_successfull' );
function epdq_transaction_successfull( $order_id ) {
	global $woocommerce;

	if ( !$order_id )
		return;
	$order = new WC_Order( $order_id );


			$accepted = array(4, 5, 9, 41, 51, 91);
			$STATUS = $_REQUEST['STATUS'];
			$ncerror = $_REQUEST['NCERROR'];

			$dienote = '<p>Transection result is uncertain.<p>';
			$dienote .= '<p>Status Code: ' . $STATUS . ' - ' . get_epdq_status_code($STATUS) . '';
			$dienote .= '<br>Error Code: ' . $ncerror . ' - ' . get_epdq_ncerror($ncerror) . '</p>';
			$died = '';
			$died .= $dienote;
			$died .= '<p>Your order is cancelled and your cart is emptied.';
			$died .= '<br>Go to your <a href="' . get_permalink(get_option('woocommerce_myaccount_page_id')) . '">account</a> to process your order again or ';
			$died .= 'go to <a href="' . home_url() . '">homepage</a></p>';

			if (in_array($STATUS, $accepted)) {

					if (!empty($_REQUEST['ORDERID']))
							$note = 'Order ID: ' . $_REQUEST['ORDERID'] . '.<br><br>'; //	order id
					if (!empty($_REQUEST['AMOUNT']))
							$note .= 'Amount: ' . $_REQUEST['AMOUNT'] . '.<br><br>'; //	amount
					if (!empty($_REQUEST['CURRENCY']))
							$note .= 'Order currency: ' . $_REQUEST['CURRENCY'] . '.<br><br>'; //	order currency
					if (!empty($_REQUEST['PM']))
							$note .= 'Payment Method: ' . $_REQUEST['PM'] . '.<br><br>'; //	payment method
					if (!empty($_REQUEST['ACCEPTANCE']))
							$note .= 'Acceptance code returned by acquirer: ' . $_REQUEST['ACCEPTANCE'] . '.<br><br>';    //	acceptance
					if (!empty($_REQUEST['STATUS']))
							$note .= 'Transaction status : ' . $_REQUEST['STATUS'] . '.<br><br>'; //	status code
					if (!empty($_REQUEST['PAYID']))
							$note .= 'Payment reference in EPDQ system: ' . $_REQUEST['PAYID'] . '.<br><br>'; //	pay id
					if (!empty($_REQUEST['NCERROR']))
							$note .= 'Error Code: ' . $_REQUEST['NCERROR'] . '.<br><br>'; //	ncerror
					if (!empty($_REQUEST['BRAND']))
							$note .= 'Card brand (EPDQ system derives this from the card number) : ' . $_REQUEST['BRAND'] . '.<br><br>'; //	brand

					if (!empty($_REQUEST['TRXDATE']))
							$note .= 'Transaction Date: ' . $_REQUEST['TRXDATE'] . '.<br><br>'; //	date
					if (!empty($_REQUEST['CN']))
							$note .= 'Cardholder/customer name: ' . $_REQUEST['CN'] . '.<br><br>'; //	payer's name
					if (!empty($_REQUEST['IP']))
							$note .= 'Customer\'s IP: ' . $_REQUEST['IP'] . '.<br><br>'; //	payer's ip

					if (!empty($_REQUEST['AAVADDRESS']))
							$note .= 'AAV result for the address: ' . $_REQUEST['AAVADDRESS'] . ' . <br><br>'; //	aav address
					if (!empty($_REQUEST['AAVCHECK']))
							$note .= 'Result of the automatic address verification: ' . $_REQUEST['AAVCHECK'] . ' . <br><br>'; //	aav check
					if (!empty($_REQUEST['AAVZIP']))
							$note .= 'AAV result for the zip code: ' . $_REQUEST['AAVZIP'] . ' . <br><br>'; // aav zip

					if (!empty($_REQUEST['CCCTY']))
							$note .= 'Country where the card was issued: ' . $_REQUEST['CCCTY'] . ' . <br><br>';
					if (!empty($_REQUEST['COMPLUS']))
							$note .= 'Custom value passed: ' . $_REQUEST['COMPLUS'] . ' . <br><br>';

					if (!empty($_REQUEST['CVCCHECK']))
							$note .= 'Result of the card verification code check: ' . $_REQUEST['CVCCHECK'] . ' . <br><br>';
					if (!empty($_REQUEST['ECI']))
							$note .= 'Electronic Commerce Indicator: ' . $_REQUEST['ECI'] . ' . <br><br>';
					if (!empty($_REQUEST['FXAMOUNT']))
							$note .= 'FXAMOUNT: ' . $_REQUEST['FXAMOUNT'] . ' . <br><br>';
					if (!empty($_REQUEST['FXCURRENCY']))
							$note .= 'FXCURRENCY: ' . $_REQUEST['FXCURRENCY'] . ' . <br><br>';
					if (!empty($_REQUEST['IPCTY']))
							$note .= 'Originating country of the IP address: ' . $_REQUEST['IPCTY'] . ' . <br><br>';
					if (!empty($_REQUEST['SUBBRAND']))
							$note .= 'SUBBRAND: ' . $_REQUEST['SUBBRAND'] . ' . <br><br>';
					if (!empty($_REQUEST['VC']))
							$note .= 'Virtual Card type: ' . $_REQUEST['VC'] . ' . <br><br>';

							// Store these for later
							if (isset($_REQUEST['ORDERID'])) {
								update_post_meta($order->id, 'OrderID', $_REQUEST['ORDERID']);
							}
							if (isset($_REQUEST['AMOUNT'])) {
								update_post_meta($order->id, 'OrderAmount', $_REQUEST['AMOUNT']);
							}
							if (isset($_REQUEST['CURRENCY'])) {
								update_post_meta($order->id, 'OrderCurrency', $_REQUEST['CURRENCY']);
							}
							if (isset($_REQUEST['PM'])) {
								update_post_meta($order->id, 'PaymentMethod', $_REQUEST['PM']);
							}
							if (isset($_REQUEST['ACCEPTANCE'])) {
								update_post_meta($order->id, 'Acceptance', $_REQUEST['ACCEPTANCE']);
							}
							if (isset($_REQUEST['STATUS'])) {
								update_post_meta($order->id, 'Status', $_REQUEST['STATUS']);
							}
							if (isset($_REQUEST['PAYID'])) {
								update_post_meta($order->id, 'PAYID', $_REQUEST['PAYID']);
							}
							if (isset($_REQUEST['NCERROR'])) {
								update_post_meta($order->id, 'NCERROR', $_REQUEST['NCERROR']);
							}
							if (isset($_REQUEST['BRAND'])) {
								update_post_meta($order->id, 'BRAND', $_REQUEST['BRAND']);
							}
							if (isset($_REQUEST['TRXDATE'])) {
								update_post_meta($order->id, 'TRXDATE', $_REQUEST['TRXDATE']);
							}
							if (isset($_REQUEST['IP'])) {
								update_post_meta($order->id, 'IP', $_REQUEST['IP']);
							}
							update_post_meta( $order->id, '_transaction_id', $_REQUEST['PAYID'] );



					$woocommerce->cart->empty_cart();

					if (in_array($STATUS, array(4, 5, 9))) {
						$noteTitle = 'Barclay ePDQ transaction is confirmed.';
						$order->add_order_note($note);
						$order->add_order_note($noteTitle);
						$order->payment_complete();
					}

					if (in_array($STATUS, array(41, 51, 91))) {
							$note = 'Barclay ePDQ transaction is awaiting for confirmation.<br>';
							$note .= $note;
							$order->update_status('on-hold', $note);
					}

			} elseif ($STATUS == 2 || $STATUS == 93) {
					$dienote .= '<br>Order is failed.';
					$order->update_status('failed', $dienote);
					$woocommerce->cart->empty_cart();
			} elseif ($STATUS == 52 || $STATUS == 92) {
					$dienote .= '<br>Order is failed.';
					$order->update_status('failed', $dienote);
					$woocommerce->cart->empty_cart();
			} elseif ($STATUS == 1) {
					$dienote .= '<br>Order is cancelled.';
					$order->update_status('cancelled', $dienote);
					$woocommerce->cart->empty_cart();
			} else {
					$dienote .= '<br>Order is failed.';
					$order->update_status('failed', $dienote);
					$woocommerce->cart->empty_cart();
			}


			//wp_redirect( get_return_url( $order ) );
			//exit;

}
